/*
 *
 * Copyright (c) International Business Machines  Corp., 2005
 * This program is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY;  without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 * the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program;  if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Test name: memsteal
 * Author: Paul Larson <pl@us.ibm.com>
 * Description: simple memory allocator
 */

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

int main(int argc, char **argv)
{
	int i;
	size_t memsize;
	char *chunk;

	if (argc != 2) {
		printf("usage: memsteal [Memory in MB]\n"
		       "Allocates given amount of memory, touches the pages,\n"
		       "and waits for a signal to exit.\n\n");
		exit(1);
	}
	memsize = atol(argv[1]) * 1024 * 1024;
	chunk = mmap(0, memsize, PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, 0, 0);
	if (chunk == NULL) {
		perror("mmap()");
		exit(1);
	}
	for(i=0;i<memsize;i+=4096) {
		chunk[i]='a';
	}
	pause();
	exit(0);
}
